## martchus-cpp-utilities 5.11.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3.0 FATAL_ERROR)

project(c++utilities)

# add project files
set(HEADER_FILES
    application/argumentparser.h
    application/commandlineutils.h
    application/fakeqtconfigarguments.h
    application/global.h
    chrono/datetime.h
    chrono/period.h
    chrono/timespan.h
    chrono/format.h
    conversion/binaryconversion.h
    conversion/binaryconversionprivate.h
    conversion/conversionexception.h
    conversion/stringconversion.h
    conversion/stringbuilder.h
    io/ansiescapecodes.h
    io/binaryreader.h
    io/binarywriter.h
    io/bitreader.h
    io/buffersearch.h
    io/copy.h
    io/inifile.h
    io/path.h
    io/nativefilestream.h
    io/misc.h
    misc/flagenumclass.h
    misc/math.h
    misc/multiarray.h
    misc/parseerror.h
    misc/traits.h
    misc/levenshtein.h
    tests/testutils.h
    tests/cppunit.h
    tests/outputcheck.h)
set(SRC_FILES
    application/argumentparserprivate.h
    application/argumentparser.cpp
    application/commandlineutils.cpp
    application/fakeqtconfigarguments.cpp
    chrono/datetime.cpp
    chrono/period.cpp
    chrono/timespan.cpp
    conversion/conversionexception.cpp
    conversion/stringconversion.cpp
    io/ansiescapecodes.cpp
    io/binaryreader.cpp
    io/binarywriter.cpp
    io/bitreader.cpp
    io/buffersearch.cpp
    io/inifile.cpp
    io/path.cpp
    io/nativefilestream.cpp
    io/misc.cpp
    misc/math.cpp
    misc/parseerror.cpp
    misc/levenshtein.cpp
    tests/testutils.cpp)

set(TEST_HEADER_FILES)
set(TEST_SRC_FILES
    tests/cppunit.cpp
    tests/conversiontests.cpp
    tests/iotests.cpp
    tests/chronotests.cpp
    tests/argumentparsertests.cpp
    tests/traitstests.cpp
    tests/mathtests.cpp
    tests/misctests.cpp)

set(CMAKE_MODULE_FILES
    cmake/modules/BasicConfig.cmake
    cmake/modules/ConfigHeader.cmake
    cmake/modules/LibraryTarget.cmake
    cmake/modules/TestUtilities.cmake
    cmake/modules/TestTarget.cmake
    cmake/modules/AppTarget.cmake
    cmake/modules/WindowsResources.cmake
    cmake/modules/TemplateFinder.cmake
    cmake/modules/Doxygen.cmake
    cmake/modules/ListToString.cmake
    cmake/modules/ShellCompletion.cmake
    cmake/modules/3rdParty.cmake)
set(CMAKE_TEMPLATE_FILES
    cmake/templates/bash-completion.sh.in
    cmake/templates/Config.cmake.in
    cmake/templates/config.h.in
    cmake/templates/desktop.in
    cmake/templates/appdata.xml.in
    cmake/templates/doxygen.in
    cmake/templates/global.h.in
    cmake/templates/version.h.in
    cmake/templates/template.pc.in)
set(SCRIPT_FILES)
if (MINGW)
    list(APPEND CMAKE_TEMPLATE_FILES cmake/templates/windows.rc.in)
    list(APPEND SCRIPT_FILES scripts/wine.sh)
endif ()

set(DOC_FILES README.md doc/buildvariables.md doc/testapplication.md)
set(EXTRA_FILES tests/calculateoverallcoverage.awk coding-style.clang-format)

# required to include CMake modules from own project directory
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" "${CMAKE_MODULE_PATH}")

# meta data
set(META_PROJECT_NAME c++utilities)
set(META_PROJECT_VARNAME CPP_UTILITIES)
set(META_APP_NAME "C++ Utilities")
set(META_APP_AUTHOR "Martchus")
set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
set(META_VERSION_MAJOR 5)
set(META_VERSION_MINOR 11)
set(META_VERSION_PATCH 1)

# find required 3rd party libraries
include(3rdParty)
use_iconv(AUTO_LINKAGE REQUIRED)

# configure use of native file buffer and its backend implementation if enabled
set(USE_NATIVE_FILE_BUFFER_BY_DEFAULT OFF)
if (WIN32
    OR ANDROID
    OR (UNIX AND NOT APPLE))
    set(USE_NATIVE_FILE_BUFFER_BY_DEFAULT ON)
endif ()
option(USE_NATIVE_FILE_BUFFER "enables use of native file buffer, affects ABI" ${USE_NATIVE_FILE_BUFFER_BY_DEFAULT})
option(FORCE_BOOST_IOSTREAMS_FOR_NATIVE_FILE_BUFFER "forces use of Boost.Iostreams for native file buffer" OFF)
if (USE_NATIVE_FILE_BUFFER)
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_NATIVE_FILE_BUFFER)
    set(NATIVE_FILE_STREAM_IMPL_FILES io/nativefilestream.cpp tests/iotests.cpp)

    # check whether __gnu_cxx::stdio_filebuf is available
    try_compile(
        GNU_CXX_STDIO_FILEBUF_AVAILABLE ${CMAKE_CURRENT_BINARY_DIR}
        SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/feature_detection/stdio_filebuf.cpp
        OUTPUT_VARIABLE GNU_CXX_STDIO_FILEBUF_CHECK_LOG)

    # use __gnu_cxx::stdio_filebuf if available or fallback to boost::iostreams::stream_buffer
    if (GNU_CXX_STDIO_FILEBUF_AVAILABLE AND NOT FORCE_BOOST_IOSTREAMS_FOR_NATIVE_FILE_BUFFER)
        message(STATUS "Using __gnu_cxx::stdio_filebuf for NativeFileStream")
        foreach (NATIVE_FILE_STREAM_IMPL_FILE ${NATIVE_FILE_STREAM_IMPL_FILES})
            set_property(
                SOURCE ${NATIVE_FILE_STREAM_IMPL_FILE}
                APPEND
                PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_GNU_CXX_STDIO_FILEBUF)
        endforeach ()
    else ()
        message(STATUS "Using boost::iostreams::stream_buffer<boost::iostreams::file_descriptor_sink> for NativeFileStream")
        use_package(TARGET_NAME Boost::iostreams PACKAGE_NAME Boost PACKAGE_ARGS "REQUIRED;COMPONENTS;iostreams")
        foreach (NATIVE_FILE_STREAM_IMPL_FILE ${NATIVE_FILE_STREAM_IMPL_FILES})
            set_property(
                SOURCE ${NATIVE_FILE_STREAM_IMPL_FILE}
                APPEND
                PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_BOOST_IOSTREAMS)
        endforeach ()
    endif ()
else ()
    message(STATUS "Using std::fstream for NativeFileStream")
endif ()

# configure required libraries for std::filesystem
option(USE_STANDARD_FILESYSTEM "uses std::filesystem; if disabled Bash completion for files and directories is not working"
       ON)
if (USE_STANDARD_FILESYSTEM)
    list(APPEND META_PRIVATE_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_STANDARD_FILESYSTEM)
    use_standard_filesystem()
else ()
    message(WARNING "The use of std::filesystem has been disabled. Bash completion for files and directories will not work.")
endif ()

# configure whether escape codes should be enabled by default
option(ENABLE_ESCAPE_CODES_BY_DEAULT "enables usage of escape codes by default" ON)
if (ENABLE_ESCAPE_CODES_BY_DEAULT)
    set_property(
        SOURCE application/argumentparser.cpp io/ansiescapecodes.cpp tests/argumentparsertests.cpp
        APPEND
        PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_ESCAPE_CODES_ENABLED_BY_DEFAULT)
else ()
    message(STATUS "Disabling use of escape codes by default.")
endif ()

# configure use of thread_local
option(ENABLE_THREAD_LOCAL "enables use of Thread-Local Storage" ON)
if (NOT ENABLE_THREAD_LOCAL)
    set_property(
        SOURCE conversion/stringconversion.cpp
        APPEND
        PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_NO_THREAD_LOCAL)
endif ()

# include modules to apply configuration
include(BasicConfig)
include(WindowsResources)
include(LibraryTarget)
include(TestTarget)
include(Doxygen)
include(ConfigHeader)

=== debian/changelog ===
martchus-cpp-utilities (5.11.1-1) unstable; urgency=medium

  [ Hannah Rittich ]
  * Initial release. Closes: #998178

 -- Nicholas D Steeves <sten@debian.org>  Thu, 10 Feb 2022 09:35:10 -0500

## martchus-cpp-utilities 5.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,8 +114,8 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 11)
-set(META_VERSION_PATCH 1)
+set(META_VERSION_MINOR 13)
+set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries
 include(3rdParty)

=== debian/changelog ===
martchus-cpp-utilities (5.13.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop 0001-namespace.patch (merged upstream).

 -- Nicholas D Steeves <sten@debian.org>  Wed, 23 Feb 2022 19:59:10 -0500

=== debian/control ===
Source: martchus-cpp-utilities
Section: libs
Priority: optional
Maintainer: Hannah Rittich <void@rittich.net>
Uploaders: Nicholas D Steeves <sten@debian.org>
Build-Depends: debhelper-compat (= 13), cmake
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/Martchus/cpp-utilities
Vcs-Browser: https://salsa.debian.org/debian/cpp-utilities
Vcs-Git: https://salsa.debian.org/debian/cpp-utilities.git

Package: libmartchus-c++utilities5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: useful C++ classes and routines used by Martchus' applications
 Martchus-cpp-utilities is a library that contains helpers for:
   * parsing command-line arguments and providing Bash completions
   * working with dates and times
   * converting primitive data types to byte-buffers, and vice versa
   (eg, between litte-endian and big-endian)
   * common string conversions/operations
   * using standard IO streams
   * using SFINAE by providing additional traits (eg, for checking whether a
   type is iteratable)
   * testing with *CppUnit*
   * CMake, with convenient modules and templates
 .
 It also provides the following convenience functions and data structures:
   * min() and max(), for any number of arguments
   * digitsum(), factorial(), powerModulo(), inverseModulo(), and orderModulo()
   * Damerau–Levenshtein distance
   * *N*-dimensional arrays

Package: libmartchus-c++utilities-dev
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, libmartchus-c++utilities5(= ${binary:Version})
Section: libdevel
Description: useful C++ classes and routines used by Martchus' applications (headers)
 Martchus-cpp-utilities is a library that contains helpers for:
   * parsing command-line arguments and providing Bash completions
   * working with dates and times
   * converting primitive data types to byte-buffers, and vice versa
   (eg, between litte-endian and big-endian)
   * common string conversions/operations
   * using standard IO streams
   * using SFINAE by providing additional traits (eg, for checking whether a
   type is iteratable)
   * testing with *CppUnit*
   * CMake, with convenient modules and templates
 .
 It also provides the following convenience functions and data structures:
   * min() and max(), for any number of arguments
   * digitsum(), factorial(), powerModulo(), inverseModulo(), and orderModulo()
   * Damerau–Levenshtein distance
   * *N*-dimensional arrays
 .
 This is the development version of the library. You will need this only if
 you intend to compile programs that use this library.

=== debian/watch ===
version=4
https://github.com/Martchus/cpp-utilities/releases /Martchus/cpp-utilities/archive/refs/tags/v(.+)\.tar\.gz

## martchus-cpp-utilities 5.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,7 +114,7 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 13)
+set(META_VERSION_MINOR 14)
 set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries

=== debian/changelog ===
martchus-cpp-utilities (5.14.0-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright file with upstream changes.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 08 Apr 2022 22:15:32 -0400

martchus-cpp-utilities (5.13.0-2) unstable; urgency=medium

  * Fix VCS links.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 11 Mar 2022 20:21:32 -0500

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://github.com/Martchus/cpp-utilities
-Vcs-Browser: https://salsa.debian.org/debian/cpp-utilities
-Vcs-Git: https://salsa.debian.org/debian/cpp-utilities.git
+Vcs-Browser: https://salsa.debian.org/debian/martchus-cpp-utilities
+Vcs-Git: https://salsa.debian.org/debian/martchus-cpp-utilities.git
 
 Package: libmartchus-c++utilities5
 Architecture: any

## martchus-cpp-utilities 5.18.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,7 +114,7 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 14)
+set(META_VERSION_MINOR 18)
 set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries

=== debian/changelog ===
martchus-cpp-utilities (5.18.0-1) unstable; urgency=medium

  * New upstream release.
  * Add myself to copyright file.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 19 Aug 2022 18:02:44 -0400

## martchus-cpp-utilities 5.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,7 +114,7 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 18)
+set(META_VERSION_MINOR 19)
 set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries

=== debian/changelog ===
martchus-cpp-utilities (5.19.0-1) unstable; urgency=medium

  * New upstream release.
  * Swap Uploader and Maintainer.  Hannah Rittich has been MIA since December
    2021.  This action will be reverted upon confirmation of intent to
    maintain martchus-cpp-utilities.

 -- Nicholas D Steeves <sten@debian.org>  Thu, 22 Sep 2022 12:34:25 -0400

## martchus-cpp-utilities 5.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -77,6 +77,7 @@
     cmake/modules/LibraryTarget.cmake
     cmake/modules/TestUtilities.cmake
     cmake/modules/TestTarget.cmake
+    cmake/modules/AppUtilities.cmake
     cmake/modules/AppTarget.cmake
     cmake/modules/WindowsResources.cmake
     cmake/modules/TemplateFinder.cmake
@@ -114,7 +115,7 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 19)
+set(META_VERSION_MINOR 20)
 set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries

=== debian/changelog ===
martchus-cpp-utilities (5.20.0-1) unstable; urgency=medium

  * New upstream release.
  * Fix watch file, because Github broke the releases mechanism.

 -- Nicholas D Steeves <sten@debian.org>  Tue, 15 Nov 2022 16:25:48 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: martchus-cpp-utilities
 Section: libs
 Priority: optional
-Maintainer: Hannah Rittich <void@rittich.net>
-Uploaders: Nicholas D Steeves <sten@debian.org>
+Maintainer: Nicholas D Steeves <sten@debian.org>
+Uploaders: Hannah Rittich <void@rittich.net>
 Build-Depends: debhelper-compat (= 13), cmake
 Rules-Requires-Root: no
 Standards-Version: 4.6.0

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export BUILD_DIR=debian/build

%:
	dh $@ --builddirectory=$(BUILD_DIR)

override_dh_auto_configure:
	# -fPIC is needed, because we want to be able to link this library into
	# a shared object
	dh_auto_configure --builddirectory=$(BUILD_DIR) -- \
		-DBUILD_SHARED_LIBS=ON \
		-DNAMESPACE=martchus

override_dh_auto_test:
	$(MAKE) -C $(BUILD_DIR) check

=== debian/watch ===
version=4
https://github.com/Martchus/cpp-utilities/tags \
  .*/v?(\d\S+)\.tar\.gz

## martchus-cpp-utilities 5.24.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.3.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)
 
 project(c++utilities)
 
@@ -84,6 +84,7 @@
     cmake/modules/Doxygen.cmake
     cmake/modules/ListToString.cmake
     cmake/modules/ShellCompletion.cmake
+    cmake/modules/DevelUtilities.cmake
     cmake/modules/3rdParty.cmake)
 set(CMAKE_TEMPLATE_FILES
     cmake/templates/bash-completion.sh.in
@@ -97,9 +98,13 @@
     cmake/templates/template.pc.in)
 set(SCRIPT_FILES)
 if (MINGW)
-    list(APPEND CMAKE_TEMPLATE_FILES cmake/templates/windows.rc.in)
     list(APPEND SCRIPT_FILES scripts/wine.sh)
 endif ()
+if (WIN32)
+    list(APPEND CMAKE_TEMPLATE_FILES cmake/templates/windows.rc.in cmake/templates/windows-cli-wrapper.rc.in
+         cmake/templates/cli-wrapper.cpp)
+endif ()
+set(EXCLUDED_FILES cmake/templates/cli-wrapper.cpp)
 
 set(DOC_FILES README.md doc/buildvariables.md doc/testapplication.md)
 set(EXTRA_FILES tests/calculateoverallcoverage.awk coding-style.clang-format)
@@ -115,14 +120,15 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 20)
-set(META_VERSION_PATCH 0)
+set(META_VERSION_MINOR 24)
+set(META_VERSION_PATCH 5)
 
 # find required 3rd party libraries
 include(3rdParty)
 use_iconv(AUTO_LINKAGE REQUIRED)
 
 # configure use of native file buffer and its backend implementation if enabled
+set(REQUIRED_BOOST_COMPONENTS "")
 set(USE_NATIVE_FILE_BUFFER_BY_DEFAULT OFF)
 if (WIN32
     OR ANDROID
@@ -152,7 +158,7 @@
         endforeach ()
     else ()
         message(STATUS "Using boost::iostreams::stream_buffer<boost::iostreams::file_descriptor_sink> for NativeFileStream")
-        use_package(TARGET_NAME Boost::iostreams PACKAGE_NAME Boost PACKAGE_ARGS "REQUIRED;COMPONENTS;iostreams")
+        list(APPEND REQUIRED_BOOST_COMPONENTS iostreams)
         foreach (NATIVE_FILE_STREAM_IMPL_FILE ${NATIVE_FILE_STREAM_IMPL_FILES})
             set_property(
                 SOURCE ${NATIVE_FILE_STREAM_IMPL_FILE}
@@ -164,6 +170,26 @@
     message(STATUS "Using std::fstream for NativeFileStream")
 endif ()
 
+# configure use of Boost.Process for launching test applications on Windows
+if (WIN32)
+    option(USE_BOOST_PROCESS "enables use of Boost.Process to launch test applications" ON)
+    if (USE_BOOST_PROCESS)
+        list(APPEND REQUIRED_BOOST_COMPONENTS filesystem)
+        list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_BOOST_PROCESS)
+        list(APPEND PRIVATE_LIBRARIES ws2_32) # needed by Boost.Asio
+        use_package(TARGET_NAME Threads::Threads PACKAGE_NAME Threads PACKAGE_ARGS REQUIRED)
+    endif ()
+endif ()
+
+# configure usage of Boost
+if (REQUIRED_BOOST_COMPONENTS)
+    set(BOOST_ARGS REQUIRED COMPONENTS ${REQUIRED_BOOST_COMPONENTS})
+    use_package(TARGET_NAME Boost::boost PACKAGE_NAME Boost PACKAGE_ARGS "${BOOST_ARGS}")
+    foreach (COMPONENT ${REQUIRED_BOOST_COMPONENTS})
+        use_package(TARGET_NAME Boost::${COMPONENT} PACKAGE_NAME Boost PACKAGE_ARGS "${BOOST_ARGS}")
+    endforeach ()
+endif ()
+
 # configure required libraries for std::filesystem
 option(USE_STANDARD_FILESYSTEM "uses std::filesystem; if disabled Bash completion for files and directories is not working"
        ON)
@@ -194,6 +220,13 @@
         PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_NO_THREAD_LOCAL)
 endif ()
 
+# configure use of platform-specific APIs for optimizing CopyHelper
+option(USE_PLATFORM_SPECIFIC_API_FOR_OPTIMIZING_COPY_HELPER
+       "enables use of platform-specific APIs for optimizing CopyHelper" OFF)
+if (USE_PLATFORM_SPECIFIC_API_FOR_OPTIMIZING_COPY_HELPER)
+    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_PLATFORM_SPECIFIC_API_FOR_OPTIMIZING_COPY_HELPER)
+endif ()
+
 # include modules to apply configuration
 include(BasicConfig)
 include(WindowsResources)

=== debian/changelog ===
martchus-cpp-utilities (5.24.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop Hannah Rittich, who has been MIA for two years, from Uploaders.
  * Update copyright file with upstream changes, and update my copyright
    years.
  * Update standards version to 4.6.2 (no changes required).

 -- Nicholas D Steeves <sten@debian.org>  Tue, 16 Jan 2024 18:35:10 -0500

martchus-cpp-utilities (5.24.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Nicholas D Steeves ]
  * New upstream release.

 -- Nicholas D Steeves <sten@debian.org>  Wed, 12 Jul 2023 15:55:30 -0400

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Section: libs
 Priority: optional
 Maintainer: Nicholas D Steeves <sten@debian.org>
-Uploaders: Hannah Rittich <void@rittich.net>
 Build-Depends: debhelper-compat (= 13), cmake
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/Martchus/cpp-utilities
 Vcs-Browser: https://salsa.debian.org/debian/martchus-cpp-utilities
 Vcs-Git: https://salsa.debian.org/debian/martchus-cpp-utilities.git

## martchus-cpp-utilities 5.24.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -121,7 +121,7 @@
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
 set(META_VERSION_MINOR 24)
-set(META_VERSION_PATCH 5)
+set(META_VERSION_PATCH 7)
 
 # find required 3rd party libraries
 include(3rdParty)

=== debian/changelog ===
martchus-cpp-utilities (5.24.7-1) unstable; urgency=medium

  * Acknowledge NMU.
  * New upstream release.
  * Update standards version to 4.7.0 (no changes required).

 -- Nicholas D Steeves <sten@debian.org>  Thu, 25 Apr 2024 19:22:11 -0400

martchus-cpp-utilities (5.24.5-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062843

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Feb 2024 11:12:30 +0000

## martchus-cpp-utilities 5.24.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -96,10 +96,6 @@
     cmake/templates/global.h.in
     cmake/templates/version.h.in
     cmake/templates/template.pc.in)
-set(SCRIPT_FILES)
-if (MINGW)
-    list(APPEND SCRIPT_FILES scripts/wine.sh)
-endif ()
 if (WIN32)
     list(APPEND CMAKE_TEMPLATE_FILES cmake/templates/windows.rc.in cmake/templates/windows-cli-wrapper.rc.in
          cmake/templates/cli-wrapper.cpp)
@@ -121,7 +117,7 @@
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
 set(META_VERSION_MINOR 24)
-set(META_VERSION_PATCH 7)
+set(META_VERSION_PATCH 9)
 
 # find required 3rd party libraries
 include(3rdParty)

=== debian/changelog ===
martchus-cpp-utilities (5.24.9-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 21 Jun 2024 21:52:59 -0400

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,17 @@
 Section: libs
 Priority: optional
 Maintainer: Nicholas D Steeves <sten@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/Martchus/cpp-utilities
 Vcs-Browser: https://salsa.debian.org/debian/martchus-cpp-utilities
 Vcs-Git: https://salsa.debian.org/debian/martchus-cpp-utilities.git
 
-Package: libmartchus-c++utilities5
+Package: libmartchus-c++utilities5t64
+Provides: ${t64:Provides}
+Replaces: libmartchus-c++utilities5
+Breaks: libmartchus-c++utilities5 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -35,7 +38,7 @@
 Package: libmartchus-c++utilities-dev
 Architecture: any
 Multi-Arch: no
-Depends: ${misc:Depends}, libmartchus-c++utilities5(= ${binary:Version})
+Depends: ${misc:Depends}, libmartchus-c++utilities5t64(= ${binary:Version})
 Section: libdevel
 Description: useful C++ classes and routines used by Martchus' applications (headers)
  Martchus-cpp-utilities is a library that contains helpers for:

## martchus-cpp-utilities 5.27.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -85,7 +85,8 @@
     cmake/modules/ListToString.cmake
     cmake/modules/ShellCompletion.cmake
     cmake/modules/DevelUtilities.cmake
-    cmake/modules/3rdParty.cmake)
+    cmake/modules/3rdParty.cmake
+    cmake/modules/3rdPartyFunctions.cmake)
 set(CMAKE_TEMPLATE_FILES
     cmake/templates/bash-completion.sh.in
     cmake/templates/Config.cmake.in
@@ -116,12 +117,21 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 24)
-set(META_VERSION_PATCH 9)
+set(META_VERSION_MINOR 27)
+set(META_VERSION_PATCH 3)
 
 # find required 3rd party libraries
 include(3rdParty)
-use_iconv(AUTO_LINKAGE REQUIRED)
+option(USE_ICONV "uses iconv/libiconv; if disabled character set conversions and features depending on it are not available"
+       ON)
+if (USE_ICONV)
+    use_iconv(AUTO_LINKAGE REQUIRED)
+else ()
+    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_NO_ICONV)
+endif ()
+
+# do not rely on legacy behavior of FlagEnumClass (TODO v6: remove macro, make new behavior the default)
+list(APPEND META_PRIVATE_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_FLAG_ENUM_CLASS_NO_LEGACY_AND)
 
 # configure use of native file buffer and its backend implementation if enabled
 set(REQUIRED_BOOST_COMPONENTS "")
@@ -187,13 +197,30 @@
 endif ()
 
 # configure required libraries for std::filesystem
-option(USE_STANDARD_FILESYSTEM "uses std::filesystem; if disabled Bash completion for files and directories is not working"
-       ON)
+option(USE_STANDARD_FILESYSTEM
+       "uses std::filesystem; if disabled Bash completion for files and directories and archiving utilities are disabled" ON)
 if (USE_STANDARD_FILESYSTEM)
     list(APPEND META_PRIVATE_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_STANDARD_FILESYSTEM)
     use_standard_filesystem()
 else ()
-    message(WARNING "The use of std::filesystem has been disabled. Bash completion for files and directories will not work.")
+    message(
+        WARNING
+            "The use of std::filesystem has been disabled. Bash completion for files and directories will not work and archiving utilities are disabled."
+    )
+endif ()
+
+# configure usage of libarchive
+option(USE_LIBARCHIVE "uses libarchive; if disabled archiving utilities will not be available" OFF)
+if (USE_LIBARCHIVE)
+    if (NOT USE_STANDARD_FILESYSTEM)
+        message(FATAL_ERROR "Unable to use USE_LIBARCHIVE without USE_STANDARD_FILESYSTEM.")
+    endif ()
+    use_package(TARGET_NAME LibArchive::LibArchive PACKAGE_NAME LibArchive)
+    list(APPEND HEADER_FILES io/archive.h)
+    list(APPEND SRC_FILES io/archive.cpp)
+    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_LIBARCHIVE)
+else ()
+    set(EXCLUDED_FILES io/archive.h io/archive.cpp)
 endif ()
 
 # configure whether escape codes should be enabled by default
@@ -223,8 +250,13 @@
     list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME}_USE_PLATFORM_SPECIFIC_API_FOR_OPTIMIZING_COPY_HELPER)
 endif ()
 
-# include modules to apply configuration
+# apply basic configuration
 include(BasicConfig)
+
+# set the package name of c++utilities itself as it is used in the config module template
+set(CPP_UTILITIES_PACKAGE "${NAMESPACE_PREFIX}${META_PROJECT_NAME}${META_CONFIG_SUFFIX}")
+
+# include further modules to apply configuration
 include(WindowsResources)
 include(LibraryTarget)
 include(TestTarget)

=== debian/changelog ===
martchus-cpp-utilities (5.27.3-1) unstable; urgency=medium

  * New upstream release.
  * Rebase patch queue onto this release:
    - Drop 0001-Fix-AppStream-warning-metainfo-filename-cid-mismatch.patch
  * Import updated upstream copyright statements, and update my copyright
    years.
  * Update standards version to 4.7.2 (no changes required).
  * Upload to unstable.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 14 Mar 2025 08:22:58 -0600

martchus-cpp-utilities (5.26.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add 0001-Fix-AppStream-warning-metainfo-filename-cid-mismatch.patch.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 15 Nov 2024 22:41:46 -0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Nicholas D Steeves <sten@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/Martchus/cpp-utilities
 Vcs-Browser: https://salsa.debian.org/debian/martchus-cpp-utilities
 Vcs-Git: https://salsa.debian.org/debian/martchus-cpp-utilities.git

## martchus-cpp-utilities 5.28.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -117,8 +117,8 @@
 set(META_APP_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}")
 set(META_APP_DESCRIPTION "Useful C++ classes and routines such as argument parser, IO and conversion utilities")
 set(META_VERSION_MAJOR 5)
-set(META_VERSION_MINOR 27)
-set(META_VERSION_PATCH 3)
+set(META_VERSION_MINOR 28)
+set(META_VERSION_PATCH 0)
 
 # find required 3rd party libraries
 include(3rdParty)

=== debian/changelog ===
martchus-cpp-utilities (5.28.0-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Wed, 11 Feb 2026 23:28:45 +0100

martchus-cpp-utilities (5.28.0-1) unstable; urgency=medium

  * New upstream release.
  * Resolve lintian W: old-fsf-address-in-copyright-file by referring to
    GNU's website.
  * Set upstream metadata fields: Repository.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 04 Apr 2025 21:18:21 -0400
